#include <Wire.h> // biblioteka I2C
#include <RtcDS3231.h> // biblioteka dla DS3231
#include <OneWire.h> //biblioteka OneWire
#include <DallasTemperature.h> //bibloteka DS18B20
RtcDS3231<TwoWire> zegar(Wire); //obiekt zegar RTC 
OneWire obiektOneWire(A0); //wykorzystujemy pin A0
DallasTemperature czujniki(&obiektOneWire);
int liczbaCzujnikow; DeviceAddress tmpAdresyCzujnikow;

void setup(void)   { 
 zegar.Begin(); Serial.begin(9600); czujniki.begin();
 RtcDateTime czasKompilacji = RtcDateTime(__DATE__, __TIME__);
 if (!zegar.IsDateTimeValid()) zegar.SetDateTime(czasKompilacji);
 if (!zegar.GetIsRunning())   zegar.SetIsRunning(true); 
 RtcDateTime czasAktualny = zegar.GetDateTime();  
 if(czasAktualny<czasKompilacji) zegar.SetDateTime(czasKompilacji); 
 liczbaCzujnikow = czujniki.getDeviceCount();  }
 
void loop(void)  { 
 czujniki.requestTemperatures(); 
 RtcDateTime czasAktualny = zegar.GetDateTime();
 printDateTime(czasAktualny);  Serial.print(" ");
 for(int i=0;i<liczbaCzujnikow; i++)   { 
 czujniki.getAddress(tmpAdresyCzujnikow, i);
 float tempC = czujniki.getTempC(tmpAdresyCzujnikow);
 Serial.print("T");   Serial.print(i,DEC);
 Serial.print(": "); Serial.print(tempC);
 Serial.print("\xC2\xB0"); Serial.print("C; "); }
 Serial.println(); delay(10000); } // czekaj 10 sekund

//poniżej definicja funkcji formatującej i drukującej czas i datę
#define countof(a) (sizeof(a) / sizeof(a[0]))
void printDateTime(const RtcDateTime& dt) { char datestring[26]; 
 snprintf_P(datestring, countof(datestring),
 PSTR("Czas %04u.%02u.%02u %02u:%02u:%02u;"),
 dt.Year(),dt.Month(),dt.Day(),dt.Hour(),dt.Minute(),dt.Second());
 Serial.print(datestring); } //wyślij do konsoli



